#! /bin/sh
# the next line restarts using wish \
exec wish "$0" ${1+"$@"}

# ----------------------------------------------------------------------
# Copyright (c) 2019 Richard Ellis
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation 51
# Franklin Street, Suite 500 Boston, MA 02110-1335
# ----------------------------------------------------------------------

foreach font [font names] {
  font configure $font -size [expr {abs([font configure $font -size])}]
}

frame .f1
text .f1.text
scrollbar .f1.vsb
grid .f1.text .f1.vsb -sticky news
grid columnconfigure .f1 0 -weight 1
grid rowconfigure .f1 0 -weight 1

grid .f1 - - - - -sticky news 

proc status {args} {
  .f1.text insert end [join $args]\n
  .f1.text see end
}

button .b1 -text "Get Clipboard" -command {
  if {[catch {set str [clipboard get]} e1 e2]} {
    status No Clipboard contents available
  } else {
    status Clipboard: '$str'
  }
}

button .b2 -text "Get X11 PRIMARY" -command {
  if {[catch {set str [selection get -selection PRIMARY]} e1 e2]} {
    status No X11 PRIMARY selection available
  } else {
    status X11 PRIMARY '$str'
  }
}

button .b3 -text "Get X11 CLIPBOARD" -command {
  if {[catch {set str [selection get -selection CLIPBOARD]} e1 e2]} {
    status No X11 CLIPBOARD selection available
  } else {
    status X11 CLIPBOARD '$str'
  }
}

button .b4 -text "Get X11 SECONDARY" -command {
  if {[catch {set str [selection get -selection SECONDARY]} e1 e2]} {
    status No X11 SECONDARY selection available
  } else {
    status X11 SECONDARY '$str'
  }
}

grid .b1 .b2 .b3 .b4 -sticky news 
